* File of the Project "1153" - 3_macroind.do
* Content: 1) Adjust the file with the macroindicators for missing values (this part is no longer used, we instead deflate in file 4 with a seperate CPI from the OECD). 2) Construct Mass Layoff Indicators at the Firm Level

clear
*set max_memory 20g
cap log close

log using "$log/3_macroind.log", replace

use "$orig/macroind.dta", clear
rename year calyr
set obs 36
replace calyr=2010 in 36

* 09 an 10 are missing in the cpi so here I just extrapolate
gen aa=cpi2000 if calyr==2008
gen bb=cpi2000 if calyr==1975

egen a=min(aa)
egen b=min(bb)
gen g=(a/b)^(1/(2008-1975))
replace cpi2000=cpi2000[_n-1]*g in 35
replace cpi2000=cpi2000[_n-1]*g in 36

replace u_ger=u_west if calyr<1991
rename u_ger urate

replace gdp_ger=gdp_west if calyr<1991
rename gdp_ger growthrate

keep cpi2000 calyr urate growthrate

save "$data/cpi_germ.dta", replace


** CONSTRUCT MASS LAYOFF INDICATORS AT THE FIRM LEVEL

use "$orig/liab_lm_9310_v1_bhp_basis_v1", clear
label language en

* a masslayoff happened if 1) employment reduction by >25%, 2) but no firm death, 3)at firms with more than 25 employees. the rest is additional robustness criteria
bys betnr: gen masslo=(az_ges_vz[_n]/az_ges_vz[_n-2]<.75 & az_ges_vz[_n]/az_ges_vz[_n-2]>.01 &az_ges_vz[_n-2]>25 &az_ges_vz[_n-2]/az_ges_vz[_n-3]<1.3 &az_ges_vz[_n+1]/az_ges_vz[_n-2]<.9 &jahr[_n+1]-jahr[_n-3]==4)
label var masslo "Mass layoff indicator. Reduction of 25% over 2 years. Min 25 employees"

* other specifications (not used)
*bys betnr: gen masslo=(az_ges_vz[_n]/az_ges_vz[_n-2]<.7 & az_ges_vz[_n]/az_ges_vz[_n-2]>.01 &az_ges_vz[_n-2]>50 &az_ges_vz[_n-2]/az_ges_vz[_n-3]<1.3 &az_ges_vz[_n+1]/az_ges_vz[_n-2]<.9 &jahr[_n+1]-jahr[_n-3]==4)
*bys betnr: gen masslo2=(az_ges_vz[_n]/az_ges_vz[_n-2]<.8 & az_ges_vz[_n]/az_ges_vz[_n-2]>.01 &az_ges_vz[_n-2]>50 &az_ges_vz[_n-2]/az_ges_vz[_n-3]<1.3 &az_ges_vz[_n+1]/az_ges_vz[_n-2]<.9 &jahr[_n+1]-jahr[_n-3]==4)
*bys betnr: gen masslo3=(az_ges_vz[_n]/az_ges_vz[_n-1]<.7 & az_ges_vz[_n]/az_ges_vz[_n-1]>.01 &az_ges_vz[_n-1]>50 &az_ges_vz[_n-1]/az_ges_vz[_n-2]<1.3 &az_ges_vz[_n+1]/az_ges_vz[_n-1]<.9 &jahr[_n+1]-jahr[_n-2]==3)
*bys betnr: gen masslo4=(az_ges_vz[_n]/az_ges_vz[_n-1]<.8 & az_ges_vz[_n]/az_ges_vz[_n-1]>.01 &az_ges_vz[_n-1]>50 &az_ges_vz[_n-1]/az_ges_vz[_n-2]<1.3 &az_ges_vz[_n+1]/az_ges_vz[_n-1]<.9 &jahr[_n+1]-jahr[_n-2]==3)
*label var masslo "Mass layoff indicator. Reduction of 30% over 2 years. Min 50 employees"
*label var masslo2 "Mass layoff indicator. Reduction of 20% over 2 years. Min 50 employees"
*label var masslo3 "Mass layoff indicator. Reduction of 30% over 1 year. Min 50 employees"
*label var masslo4 "Mass layoff indicator. Reduction of 20% over 1 year. Min 50 employees"

rename jahr calyr
keep betnr masslo* grd_jahr calyr az_ges_vz w93_3_gen te_med

save "$data/masslayoff.dta", replace
