* File of the Project "1153" - 8_estimation_b_basic.do
* Content: 	1) The first part estimates an age-depentdent learning learning function structurally
*			2) The second part reports the parameters and computes GMM standard errors -- for a detailed description of how the code does this see below


**********************************************************************************
*************************PART 1: ESTIMATING MODEL PARAMTERS *******************
********************************************************************************


forval pp=1/2{

if `pp'==1{
use "$data/estimation_sample_fo.dta", clear
capture log close
log using "$log/8_estimation_d_yo_fo.log", replace
}
else if `pp'==2{
use "$data/estimation_sample.dta", clear
capture log close
log using "$log/8_estimation_d_yo.log", replace
}
/*
keep if calyr<2003 & calyr>1999

tab age
gen old_ch=0
replace old_ch=1 if age>39 & calyr==2000
bys persnr: egen old=max(old_ch)
sum old if calyr>1999 & calyr<2003
gen young=1-old
drop old_ch age
*/

if `pp'==2{
local eta_uyy= .101 //.1*1.25
local eta_uyo=.1895 //.09/1.25
local eta_0y=.008657 //.005/1.5
local eta_uoo=.087976 //.08*1.2
local eta_uoy=.05334 //.07/1.3
local eta_0o=-.003339 // .002*1.8
}
if `pp'==1{
local eta_uyy= .101 //.1*1.25
local eta_uyo=.1895 //.09/1.25
local eta_0y=.008657 //.005/1.5
local eta_uoo=.087976 //.08*1.2
local eta_uoy=.05334 //.07/1.3
local eta_0o=-.003339 // .002*1.8
}

local beta=.95
local eps=.1
local i=10
local noi=.00000031
local dis2=10
local itcount=0
local itcount2=0
local maxit=600
local maxit2=600
local dgs=1000000

tsset persnr calyr
sort teamid avw


gen znew=0
gen Ez=0
gen zu_o=0
gen zu_y=0
gen n_o=0
gen n_y=0
gen dis=0
gen dz=0
gen rhs1=0
gen rhs2=0
gen z=1500 //INITIAL GUESS FOR Z

gen old=1
replace old=0 if age<40
gen young=1-old


bys teamid: gen ts=_N
by teamid: egen ts_o=total(old)
by teamid: gen ts_y=ts-ts_o


gen z_o=z*old
gen z_y=z*young

gen zg_extr=0


while `dis2'>`eps'/30000{ // THE OUTER LOOP RUNS UNITL \ETA_UP AND \ETA_DOWN CONVERGE
local i=30
gsort teamid -z

quietly{
while `i'>`eps'/10{ // THE INNER LOOP RUNS UNTIL Z CONVERGES
gsort teamid -z
bys teamid: replace zu_y=sum(z_y)-z_y
by teamid: replace zu_o=sum(z_o)-z_o
by teamid: replace n_o=sum(old)-old
by teamid: replace n_y=sum(young)-young

replace Ez=1/(ts-1)*((`eta_uyy')*(zu_y-n_y*z)+(`eta_uyo')*(zu_o-n_o*z))+z*(1+`eta_0y') if young==1
replace Ez=1/(ts-1)*((`eta_uoy')*(zu_y-n_y*z)+(`eta_uoo')*(zu_o-n_o*z))+z*(1+`eta_0o') if young==0

replace znew=avw+`beta'*Ez
replace dis=abs(znew-z)
replace z=znew
replace z_o=z*old
replace z_y=z*young

sum(dis)

local i=(r(mean))
local itcount2=`itcount2'+1

* in case z does not converge sufficiently fast
if `itcount2'>`maxit2'{
local i=0
display "went over iteration limit inner loop'"
}
}

local itcount2=0

* Construct Z'-Z and regress on the learning potential to up and down to get updates for eta
sort persnr calyr
by persnr: replace dz=F1.z/z-1

/*
centile dz, centile(1 99)
local lower=r(c_1)
local upper=r(c_2)
replace zg_extr=1 if dz!=.n & (dz<`lower' | dz>`upper')
*/

replace rhs1=1/(ts-1)*(zu_y-z*n_y)/z
replace rhs2=1/(ts-1)*(zu_o-z*n_o)/z

quietly reg dz rhs1 rhs2 if young==1 

mat aa_y=e(b)
  mat list aa_y
quietly reg dz rhs1 rhs2 if young==0 
mat aa_o=e(b)
 mat list aa_o

}

noi mat list aa_y
noi mat list aa_o
*sum z*
mat obs = `e(N)'
* this updates eta according to a routine we have found to be working in simulations


local eta_uyy = `eta_uyy'+.35*(`=aa_y[1,1]'-`eta_uyy')
local eta_uyo = `eta_uyo'+.175*(`=aa_y[1,2]'-`eta_uyo')
local eta_0y = `eta_0y'+.15*(`=aa_y[1,3]'-`eta_0y')
local eta_uoo = `eta_uoo'+.35*(`=aa_o[1,2]'-`eta_uoo')
local eta_uoy = `eta_uoy'+.1*(`=aa_o[1,1]'-`eta_uoy')
local eta_0o = `eta_0o'+.15*(`=aa_o[1,3]'-`eta_0o')

local obs =`=obs[1,1]'

display floor(`eta_uyy'*`dgs')/`dgs' "  "  floor(`eta_uyo'*`dgs')/`dgs' "  "  floor(`eta_0y'*`dgs')/`dgs' " " floor(`eta_uoo'*`dgs')/`dgs' "  "  floor(`eta_uoy'*`dgs')/`dgs' "  "  floor(`eta_0o'*`dgs')/`dgs' " Observations: "`obs'

local dis2=abs(`eta_uyy'-`=aa_y[1,1]')+abs(`eta_uyo'-`=aa_y[1,2]')

* in case etas dont converge sufficiently fast
local itcount=`itcount'+1
if `itcount'>`maxit'{
local dis2=0
display "went over iteration limit outer loop'"
}

}

gen eta_uyy_hat=`eta_uyy'
gen eta_uyo_hat=`eta_uyo'
gen eta_0y_hat = `eta_0y'
gen eta_uoo_hat=`eta_uoo'
gen eta_uoy_hat=`eta_uoy'
gen eta_0o_hat = `eta_0o'
gen observ=`obs'

xtile zpct = z , nquantiles(10)

if `pp'==1{
save "$data/estimation_results_yo_fo2.dta", replace
}
if `pp'==2{
save "$data/estimation_results_yo2.dta", replace
}
timer off 1
timer list 1
}

display "**********************************************************************************"
display "*************************PART 4: Computing Standard Errors *******************"
display "********************************************************************************"

capture log close
log using "$log/8_estimation_yo.log", replace

forval pp=1/2{

if `pp'==1{
use "$data/estimation_results_yo_fo2.dta", clear
}
else if `pp'==2{
use "$data/estimation_results_yo2.dta", clear
}

*Parameter estimates along with number of observations used in the structural estimation
sum eta*
sum observ


**** EXPLANATION OF THE FOLLOWING CODE TO CONSTRUCT GMM STANDARD ERRORS FOR STRUCTURAL ESTIMATION ****
* The next block computes GMM standard errors for the parameters estimated structurally above.
* the notation pretty much follows the Wikipedia notation for GMM:
* we construct auxiliary matrices G and E where
* G stacks the gradient of the moment conditions with respect to parameter pertubations around the point estimates while
* Omega is contains the cross product of the moment conditions
* We then just compute GMM standard errors using the efficient weighting matrix as (G'\Omega^{-1}G)^{-1}
* We save and print, next to the results below, the number of observations that enter the calculation of standard errors
*** for more detailed comments on how the following lines of code implement this see the file 8_estimation_basic.do which implements exactly the same steps, the only difference here is that we have several more moment conditions since we estimate a richer structural framework


quietly{

noi reg dz rhs1 rhs2 if young==1 
mat aa_y=e(b)
mat define obs_y = `e(N)'
predict m1, residuals
replace m1=0 if young==0 
gen m2=m1*rhs1 if young==1
gen m3=m1*rhs2 if young==1
replace m2=0 if young==0
replace m3=0 if young==0

noi reg dz rhs1 rhs2 if young==0
mat aa_o=e(b)
mat define obs_o = `e(N)'
predict m4, residuals
replace m4=0 if young==1 
gen m5=m4*rhs1 if young==0
gen m6=m4*rhs2 if young==0
replace m5=0 if young==1
replace m6=0 if young==1

mat define obs=obs_o[1,1]+obs_y[1,1]

matrix accum R = m1 m2 m3 m4 m5 m6, noconstant deviations
mat Omega=R/obs[1,1]

replace m1=0
replace m2=0
replace m3=0
replace m4=0
replace m5=0
replace m6=0

local dg=.001
mat G=J(6,6,0)

forval j=1/6{
mat epsg=J(1,6,0)

mat epsg[1,`j']=`dg'

local eta_uyy = aa_y[1,1]+epsg[1,1]
local eta_uyo = aa_y[1,2]+epsg[1,2]
local eta_0y = aa_y[1,3]+epsg[1,3]
local eta_uoy = aa_o[1,1]+epsg[1,4]
local eta_uoo = aa_o[1,2]+epsg[1,5]
local eta_0o = aa_o[1,3]+epsg[1,6]


local beta=.95
local eps=.1
local i=10
local noi=.00000031
local dis2=10
local itcount=0
local itcount2=0
local maxit=300
local maxit2=375
local dgs=1000000

tsset persnr calyr
sort teamid avw

gsort teamid -z

*quietly{
while `i'>`eps'{ // THE INNER LOOP RUNS UNTIL Z CONVERGES
gsort teamid -z
bys teamid: replace zu_y=sum(z_y)-z_y
by teamid: replace zu_o=sum(z_o)-z_o
by teamid: replace n_o=sum(old)-old
by teamid: replace n_y=sum(young)-young

replace Ez=1/(ts-1)*((`eta_uyy')*(zu_y-n_y*z)+(`eta_uyo')*(zu_o-n_o*z))+z*(1+`eta_0y') if young==1
replace Ez=1/(ts-1)*((`eta_uoy')*(zu_y-n_y*z)+(`eta_uoo')*(zu_o-n_o*z))+z*(1+`eta_0o') if young==0

replace znew=avw+`beta'*Ez
replace dis=abs(znew-z)
replace z=znew
replace z_o=z*old
replace z_y=z*young

sum(dis)

local i=(r(mean))
local itcount2=`itcount2'+1

* in case z does not converge sufficiently fast
if `itcount2'>`maxit2'{
local i=0
display "went over iteration limit inner loop'"
}
}

local itcount2=0

* Construct Z'-Z and regress on the learning potential to up and down to get updates for eta
sort persnr calyr
by persnr: replace dz=F1.z/z-1

replace rhs1=1/(ts-1)*(zu_y-z*n_y)/z
replace rhs2=1/(ts-1)*(zu_o-z*n_o)/z

replace m1=dz-`eta_0y'-`eta_uyy'*rhs1-`eta_uyo'*rhs2 if young==1
replace m2=m1*rhs1 if young==1
replace m3=m1*rhs2 if young==1
replace m4=dz-`eta_0o'-`eta_uoy'*rhs1-`eta_uoo'*rhs2 if young==0
replace m5=m4*rhs1 if young==0
replace m6=m4*rhs2 if young==0

sum m1
local xx=r(mean)
mat G[1,`j']=`xx'/`dg'
sum m2
local xx=r(mean)
mat G[2,`j']=`xx'/`dg'
sum m3
local xx=r(mean)
mat G[3,`j']=`xx'/`dg'
sum m4
local xx=r(mean)
mat G[4,`j']=`xx'/`dg'
sum m5
local xx=r(mean)
mat G[5,`j']=`xx'/`dg'
sum m6
local xx=r(mean)
mat G[6,`j']=`xx'/`dg'

}
}

quietly sum m1
local obs=`e(N)'

mat Omegainv=syminv(Omega)
mat v_est=((syminv(G'*Omegainv*G))/obs[1,1])

mat sd=J(1,6,0)

mat sd[1,1]=sqrt(v_est[1,1])
mat sd[1,2]=sqrt(v_est[2,2])
mat sd[1,3]=sqrt(v_est[3,3])
mat sd[1,4]=sqrt(v_est[4,4])
mat sd[1,5]=sqrt(v_est[5,5])
mat sd[1,6]=sqrt(v_est[6,6])

/*
mat list v_est
mat list G
mat list Omega
mat list Omegainv
*/

display "Observations Used in the Construction of Standard Errors: `obs'"
display "Standard Errors for \eta_uyy, \eta_yo, \eta_0y, \eta_oy, \eta_oo, \eta_0o,"

mat list sd

}




